<?php
class Dropbox_libraries{
    
    public function getAuthURL(){
        $redirect_uri = urlencode(base_url('Api/dropbox'));
        return "https://www.dropbox.com/oauth2/authorize?client_id=".DROPBOXAPIKEY."&token_access_type=offline&response_type=code&redirect_uri={$redirect_uri}";
    }

    public function getAccesToken($code){
        $url = urlencode(base_url('Api/dropbox'));
        // echo"<pre>";print_r($url);
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropbox.com/oauth2/token');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "code={$code}&grant_type=authorization_code&redirect_uri={$url}");
        curl_setopt($ch, CURLOPT_USERPWD, DROPBOXAPIKEY . ':' . DROPBOXSECRET);

        $headers = array();
        $headers[] = 'Content-Type: application/x-www-form-urlencoded';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        // echo"<pre>";print_r($result);die;
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }
    
//     public function getAccesTokenFromRefreshToken($refresh_token){
//         $ch = curl_init();
// 		curl_setopt($ch, CURLOPT_URL, 'https://api.dropbox.com/oauth2/token');
//         curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
//         curl_setopt($ch, CURLOPT_POST, 1);
//         curl_setopt($ch, CURLOPT_POSTFIELDS, "refresh_token={$refresh_token}&grant_type=refresh_token");
//         curl_setopt($ch, CURLOPT_USERPWD, $this->api_key. ':' .  $this->api_secret);

//         $headers = array();
//         $headers[] = 'Content-Type: application/x-www-form-urlencoded';
//         curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

//         $result = curl_exec($ch);
//         if (curl_errno($ch)) {
//             return array('status'=>0,'error'=>curl_error($ch));
//         }
//         curl_close($ch);
//         return array('status'=>1,'data'=>$result);
//     }
    public function getAccesTokenFromRefreshToken($refresh_token){
        $ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://api.dropbox.com/oauth2/token');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "refresh_token={$refresh_token}&grant_type=refresh_token");
        curl_setopt($ch, CURLOPT_USERPWD, DROPBOXAPIKEY. ':' .  DROPBOXSECRET);

        $headers = array();
        $headers[] = 'Content-Type: application/x-www-form-urlencoded';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);
        return $result;
    }
    public function getUserDetails( $accountID, $accessToken ){
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/users/get_account');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"account_id\":\"{$accountID}\"}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);
        // echo"<pre>";print_r($result);die;
        return $result;
    }

    public function getSpaceUsage($accessToken){
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/users/get_space_usage');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "null");
        
        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = "Content-Type: application/json";
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
        
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close ($ch);
        
        return $result;
    }
    
    public function createFolder($accessToken, $folderName, $subFolderName="" ){
        
        $path = (isset($folderName) && $folderName != '')? '/'.$folderName : $subFolderName;
        // echo"<pre>";print_r($path);die;
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/create_folder');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        // curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"/$path\",\"autorename\": false}");
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"$path\",\"autorename\": false}");
        
        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
       
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);
        return $result;
    }

    public function uploadFile($accessToken, $folderName, $file, $name){
        // echo"<pre>";print_r($folderName);
        // echo"<pre>";print_r($file);
        // echo"<pre>";print_r($name);
        // die;
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://content.dropboxapi.com/2/files/upload');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        $post = array(
            'file' => '@'.$file
        );
        
        curl_setopt($ch, CURLOPT_POSTFIELDS, file_get_contents($file) );
        // $name = basename($file);
        $args = array(
            "path" => $folderName.'/'.$name,
            "mode" => "add"
        );
        // echo"<pre>";print_r($args);die;
        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Dropbox-Api-Arg: '. json_encode($args) ;
        $headers[] = 'Content-Type: application/octet-stream';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        
//         $r = json_decode( $result, true );
//         echo"<pre>";print_r($result);
//         echo"<pre>";print_r($r);
// 		die;
        curl_close($ch);

        return json_decode($result,true);
    }

    public function deleteFile($accessToken, $path){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/delete_v2');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"{$path}\"}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }

    public function getAllFolders($accessToken, $path = null, $args = array()){
        // echo"<pre>";print_r($accessToken);die;
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();

        if($path !== null){
            $post = array(
                'path' => '/'.$path
            );
        }else{
            $post = array('path'=>'');
        }

        if(!empty($args['cursor'])){
            $post = array( 'cursor' => $args['cursor'] );
            $url = 'https://api.dropboxapi.com/2/files/list_folder/continue';
        }else{
            $url = 'https://api.dropboxapi.com/2/files/list_folder';
        }

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($post));

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        $r = json_decode( $result, true );
        // echo"<pre>";print_r($r);die;
        if(isset($r['entries'])){
            $return = array(
                'status' => 1,
                'data' => $r['entries']
            );
            if(isset($r['has_more'])){
                $return['cursor'] = $r['cursor'];
            }
        }else{
            $return = array(
                'status' => 0,
                'data' => array()
            );
        }
        
        return $return;
    }
    
    public function fileRename($accessToken, $from_path, $to_path){ // form_path =/kuldeep/kuldeep.zip ,  to_path=/kuldeep/new_name.zip
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/move_v2');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"from_path\":\"$from_path\",\"to_path\":\"$to_path\"}");
        curl_setopt($ch, CURLOPT_POST, 1);
        
        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close ($ch);
        
        return $result;
    }
  
    public function getSharedFiles($accessToken, $path){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/sharing/list_shared_links');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"{$path}\"}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }
    
    public function fileSharedLink($accessToken, $path){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/sharing/create_shared_link_with_settings');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"{$path}\",\"settings\":{\"requested_visibility\":{\".tag\":\"public\"}}}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }
    
    public function fileMoveDropboxToDropbox($accessToken, $from_path, $to_path){
        $ch = curl_init();
        $args = array(
            "from_path" => $from_path,
            "to_path" => $to_path,
            "allow_shared_folder" => "true",
            "autorename" => "false"
        );
        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/move_v2');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($args));
        curl_setopt($ch, CURLOPT_POST, 1);
        
        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close ($ch);
        return $result;
    }
    
    public function downloadFile($accessToken, $path){
        // print_r($path);die;
        
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://content.dropboxapi.com/2/files/download');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        
        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Dropbox-Api-Arg: {"path":"/kuldeep/index.php"}';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
        echo"<pre>";print_r($result);
	    echo"<pre>";print_r(json_decode($result, true));
	    die;
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close ($ch);
        
        return $result;
    }
    
    
    
    
}
?>